!2345678911234567892123456789312345678941234567895123456789612345678971234567898
!        0         0         0         0         0         0         0         0
!+
! Module: badpixfind_mod
!
! Authors:  Andy Read - MPE
!          
! Description: BADPIXFIND 
! Comments: 
! 
! $Id: module.f90,v 1.5 1998/01/13 08:39:15 gvacanti Exp $
!- 
module badpixfind_mod

  use cal
  use dal
!  use sasdal
!  use oal
  use datafilter
  use param  
  use errorHandling
  use edusoft_mod
  use emutils_mod
  use eventAttributes
  
  implicit none 
  
  private 

  public badpixfind

contains 
  
  !---------------------------------------------------------------------
  subroutine badpixfind
  !---------------------------------------------------------------------

    implicit none 

    type(DataSetT)                            :: in_events, im_mos, out_bpix, outmap 
    type(sas_evt), dimension(:), allocatable  :: mosevt
    type(ArrayT)                              :: mosev_map, map
    type(TableT)                              :: tab_events, tab_bpix 
    type(ColumnT)                             :: rawX, rawY, badPixType, &
                                                 yextent, rxcol, rycol, timecol, &
                                                 timecolF, phacol
    
    integer(kind=Int32), dimension(2)         :: imageDim
    integer(int16), dimension(:), allocatable :: a_rawX, a_rawY, a_badPixType, &
                                                 a_yextent
    integer(int32), dimension(:), allocatable :: stats, statsY, colstats, &
                                                 rawxlist, rawylist, &
                                                 typelist, yextentlist, &
                                                 mtimeindex


    integer(int16), dimension(:,:), pointer   :: FOVmap
    integer(int16), dimension(:), pointer     :: channels
    integer(int16), dimension(:), pointer     :: p_rawX, p_rawY, p_badPixType, &
                                                 p_yextent, p_rx, p_ry, p_pha, &
                                                 UpX, UpY, UpType, UpYext
    integer(kind=int32)                       :: calIval
    integer                                   :: ccdid, ccdnode, x, y, yext, &
                                                 Nbpix, Nbpix1, Nbpix2, max, &
                                                 nx, ny, npixim, n, i, usebg, &
                                                 tot_counts, extent, y0, x0, &
                                                 npix, n2_rawx, n2_rawy, &
                                                 n2_type, n2_yextent, nblocks, &
                                                 blocknr, cellsize, Npnoutwin, &
                                                 Nbpixsave, Nbpix1save, Nmapnear, &
                                                 NoutErng, goodmappix, nUp, nCCF, &
 						 usebglo, nybg, AccessType

    integer(kind=Int8), dimension(:,:), pointer :: map_arrayP, good
    integer(kind=Int8)                          :: PNmap_array(1:EPN_MAX_X,1:EPN_MAX_Y)
    integer(kind=Int8)                          :: MOSmap_array(1:EMOS_MAX_X,1:EMOS_MAX_Y)

    real(kind=double), dimension(:), pointer  :: Emin, Emax
    real(kind=Double), dimension(:), pointer  :: p_time, p_timeF
    real(kind=Double), pointer                :: valueFmos(:,:,:)
    real(kind=Double), pointer                :: valueR(:,:), valueMos(:,:)
    integer(kind=int32), pointer              :: valueI4(:,:)
    real(kind=double), pointer                :: coltot(:), colmedian(:), colhot(:)
    real(kind=double)                         :: lovalue, hivalue, calRval, &
                                                 lothresh, hithresh, psfthresh, &
                                                 locoltot, hicoltot, en_lo, en_hi, &
                                                 locolthresh, hicolthresh, &
                                                 exposure, locolmedian, &
                                                 hicolmedian, start, end, fracGTPSF, &
                                                 timestep, evtotFmos, mean, bckgrnd

    logical, dimension(:), pointer	      :: UpUp
    logical                                   :: mode1, mode2, colsearch, &
                                                 bpixOK, yextentfound, &
                                                 medianGot, fromodf, projenergy, &
                                                 rejectmosbad, warnflag, ishot, &
                                                 hasexposure, mos, calBval

    character(len=256)                        :: history,expression 
    character(len=80)                         :: filename, outmapname
    character(len=25)                         :: obsid, expid
    character(len=7)                          :: thresholdlabel, & 
                                                 columnsearchlabel !, datamode
    character(len=5)                          :: instrument

!******************************************************************************
!                 START PROGRAM
!-----------------------------------------------------------
!	GET INPUT EVENTS
!-----------------------------------------------------------
    in_events = clone(stringParameter("eventset"),"bpxftemp", TEMP, USE_ENVIRONMENT)
!    in_events = clone("pn","bpxftemp", TEMP, USE_ENVIRONMENT)
!-----------------------------------------------------------
!	GET NAME OF SECONDARY EXTENSION AND ENTER THIS
!         needs columns:  TIME RAWX RAWY PHA
!         needs keywords: EXP_ID OBS_ID 
!                         WINDOWX0 WINDOWY0 WINDOWDX WINDOWDY
!         likes keywords: EXPOSURE TELAPSE LIVETIME
!-----------------------------------------------------------
!    if (hasBlock(in_events,"PNIME1")) then	!	EPN (imag)
!      tab_events = table(in_events,"PNIME1") 
    if (hasBlock(in_events,"EVENTS")) then	!	EPN (all modes)
      tab_events = table(in_events,"EVENTS") 
    elseif (hasBlock(in_events,"M1IME1")) then	!       EMOS1 (imag)
      tab_events = table(in_events,"M1IME1")
    elseif (hasBlock(in_events,"M2IME1")) then  !       EMOS2 (imag)
      tab_events = table(in_events,"M2IME1")
!    elseif (hasBlock(in_events,"EVENTS")) then  !       EMOS1 or 2 (from emevents)
!      tab_events = table(in_events,"EVENTS")
    else 
      call error("badInput","No, or incorrectly named extension in input events file")
    endif
!-------------------------------------------------------------
!	SET CAL STATE
!-------------------------------------------------------------
    mos = .false.
    call CAL_setState(in_events)   
    call CAL_setState(accuracyLevel=1, randomize=.FALSE.)

    call CAL_getState(instrument=calIval)
    write (errstr,*) "Instrument = ",instId(calIval)
    call message(AppMsg,Verbose)
    instrument = instId(calIval)
    if (instrument == "EMOS1" .or. instrument == "EMOS2") mos = .true.
    call CAL_getState(ccdChipId=calIval)
    write (errstr,*) "CCD chip = ",calIval
    call message(AppMsg,Verbose)
    ccdid = calIval
    if (mos) then
      call CAL_getState(ccdNodeId=calIval)
      write (errstr,*) "CCD node = ",calIval
      call message(AppMsg,Verbose)
      ccdnode = calIval
    else
      ccdnode = 0 ! pn
    endif
    call CAL_getState(ccdModeId=calIval)
    write (errstr,*) "CCD mode = ",modeId(calIval)
    call message(AppMsg,Verbose)
!    call CAL_getState(filterId=calIval)
!    write (errstr,*) "Filter = ",filterId(calIval)
!    call message(AppMsg,Verbose)
    call CAL_getState(accuracyLevel=calIval)
    write (errstr,*) "Accuracy level = ",calIval
    call message(AppMsg,Verbose)
    call CAL_getState(temperature=calRval)
    write (errstr,*) "Temperature = ",calRval
    call message(AppMsg,Verbose)
    call CAL_getState(temperatureCamera=calRval)
    write (errstr,*) "Camera Temperature = ",calRval
    call message(AppMsg,Verbose)
    call CAL_getState(randomize=calBval)
    write (errstr,*) "Randomization = ",calBval
    call message(AppMsg,Verbose)
!    call CAL_setState(temperature=273.d0, temperatureCamera=273.d0, randomize=.FALSE.)
!------------------------------------------------------------
!	GET INSTRUMENT 
!------------------------------------------------------------
!    instrument = stringAttribute(tab_events,"INSTRUME")
    if (instrument /= "EPN"   .and. &
        instrument /= "EMOS1" .and. &
        instrument /= "EMOS2") then
      call error("badInstrument","Instrument not supported")
    endif
!------------------------------------------------------------
!     GET ACCESS MODE (mps = modify, pn = read)
!------------------------------------------------------------
      if (mos) then
        AccessType = MODIFY
      else
        AccessType = READ
      endif
!------------------------------------------------------------
!     GET MODE (should be got from events file)
!------------------------------------------------------------
!     datamode = stringAttribute(in_events,"DATAMODE")
!     if (datamode.eq.'TIMING'.or. &
!         datamode.eq.'timing'.or. &
!         datamode.eq.'FAST'.or. &
!         datamode.eq.'fast') then
!       call error("badMode","Mode not supported")
!     endif
!    datamode = "IMAGING (test!)"
!    write(errstr,*) "Datamode: ",datamode
!    call message(AppMsg,Verbose)
!-------------------------------------------------------------
!	GET EXPOSURE ID
!-------------------------------------------------------------
      expid = stringAttribute(tab_events,"EXP_ID")
      write(errstr,*) "Exposure id: ",expid
      call message(AppMsg,Verbose)
!-------------------------------------------------------------
!	GET OBSERVATION ID
!-------------------------------------------------------------
      obsid = stringAttribute(tab_events,"OBS_ID")
      write(errstr,*) "Observation id: ",obsid
      call message(AppMsg,Verbose)
!-------------------------------------------------------------
!	WHICH BADPIXFIND MODES? (1,2, and colsearch [part of 1]) 
!-------------------------------------------------------------
    mode1 = booleanParameter("searchbadpix")
    colsearch = booleanParameter("withsearchbadcolumn")
    mode2 = booleanParameter("userflagbadpix")
    if (.not.mode1 .and. .not.mode2) then
      call error("noBadpixfindModes","No modes chosen - badpixfind stop")
    endif
!----------------------------------------------------------------------------
!     CHECK MODE2 LISTS
!----------------------------------------------------------------------------
    if (mode2) then 
      n2_rawx = parameterCount("rawxlist")
      n2_rawy = parameterCount("rawylist")
      n2_type = parameterCount("typelist")
      n2_yextent = parameterCount("yextentlist")
      if (n2_rawX /= n2_rawy .or. n2_rawx /= n2_type .or. &
          n2_rawX /= n2_type .or. n2_rawx /= n2_yextent) then 
        call error("nonEqualLists","RAWX, RAWY, TYPE, and YEXTENT lists must be of equal sizes")
      endif
      write (errstr,*) n2_rawX," user-flagged bad pixels found"
      call message(AppMsg,Verbose)
      allocate(rawxlist(n2_rawx),rawylist(n2_rawx),&
             typelist(n2_rawx),yextentlist(n2_rawx))
    else
      allocate(rawxlist(0),rawylist(0),&
             typelist(0),yextentlist(0))
    endif
    if (mode2 .and. n2_rawx >= 1) then 
      do i = 1, n2_rawX
        rawxlist(i) = intParameter("rawxlist",i-1)
        rawylist(i) = intParameter("rawylist",i-1)
        typelist(i) = intParameter("typelist",i-1)
        yextentlist(i) = intParameter("yextentlist",i-1)
      enddo
    endif
!-------------------------------------------------------------
!	Get uplinked bad pixels
!-------------------------------------------------------------
!    call message(AppMsg,Verbose," Getting uplinked bad pixels")
    call CAL_getBadPixelList(UpX, UpY, UpType, UpYext, UpUp)
    nUp = 0
    nCCF = size(UpX)
    do n = 0, nCCF-1
!write (*,*) UpX(n),UpY(n),UpType(n),UpYext(n),UpUp(n)
      if (UpUp(n)) then 
        nUp = nUp + 1
      endif
    enddo
    write (errstr,*) "CCF: ",nCCF," bad pixel sets: ",nUp," are uplinked"
    call message(AppMsg,Verbose)
!-------------------------------------------------------------
!	CREATE BADPIXFIND FILE
!-------------------------------------------------------------
    filename = stringParameter("badpixset")
    out_bpix = dataSet(filename,CREATE)
    max = 10000
    allocate(a_rawX(max),a_rawY(max),a_badPixType(max),a_yextent(max))
!-------------------------------------------------------------
!	CALCULATE INITIAL STATS
!-------------------------------------------------------------
    Nbpix1 = 0
    Nbpix2 = 0
    Nbpix = 0
    !-------------------------------------------------------------
    !	GET ORIGIN x0, y0, GET SIZE (WINDOWS), clear arrays
    !-------------------------------------------------------------
    if (instrument == "EPN") then                  !EPN 63>64 problem
!      x0 = int16Attribute(tab_events,"WINDOWX0")+1
!      y0 = int16Attribute(tab_events,"WINDOWY0")+1
      x0 = int16Attribute(tab_events,"WINDOWX0")
      y0 = int16Attribute(tab_events,"WINDOWY0")
    else
      x0 = int16Attribute(tab_events,"WINDOWX0")
      y0 = int16Attribute(tab_events,"WINDOWY0")
    endif
    nx = int16Attribute(tab_events,"WINDOWDX")
    ny = int16Attribute(tab_events,"WINDOWDY")
    write(errstr,*) "Image origin at RAWX= ",x0,", RAWY= ",y0
    call message(AppMsg,Verbose)
    write(errstr,*) "Image size in RAWX= ",nx,", in RAWY= ",ny
    call message(AppMsg,Verbose)
    allocate(valueR(0:nx-1,0:ny-1))
    allocate(good(0:nx-1,0:ny-1))

    !???NOTE image array filled from 0 to 63, 0 to 199 (pn)
    !???NOTE image array filled from 0 to 599, 0 to 599 (mos)
    do x = 0, nx-1
      do y = 0, ny-1
        valueR(x,y) = 0.0
        good(x,y) = 1
      enddo
    enddo
    !-------------------------------------------------------------
    !	SET good to zero for uplinked pixels
    !-------------------------------------------------------------
    do n = 0, nCCF-1
!write (*,*) UpX(n),UpY(n),UpType(n),UpYext(n),UpUp(n)
      if (instrument=="EPN".and.UpY(n)==1) then	!pn edge probs??? 
        UpY(n)=UpY(n)+1
        UpYext(n)=UpYext(n)-1
      endif  
      if (UpUp(n)) then 
	if (UpX(n)-x0 >= 0 .and. UpX(n)-x0 <= nx-1) then !uplinked bad pixel in image  range
          do yext = 1, UpYext(n)
            if (UpY(n)-y0+yext-1 >= 0 .and. UpY(n)-y0+yext-1 <= ny-1) then ! yframe also
              good(UpX(n)-x0,UpY(n)-y0+yext-1) = 0
            endif
          enddo
        endif 
      endif
    enddo
    !-------------------------------------------------------------
    !	GET START/END TIMES (for flickering)
    !-------------------------------------------------------------
    nblocks = intParameter("flickertimesteps")
    if (nblocks > 1.1) then                      !if to do flickering
      timecol = column(tab_events,"TIME",AccessType)
      p_time => real64Data(timecol)
      end = -9999999999.9
      start = 9999999999.9
      do n = 0, size(p_time)-1
        if (p_time(n) > end) end = p_time(n) + 0.00001  ! to avoid edge effects >= last
        if (p_time(n) < start) start = p_time(n)
      enddo
      if (n+1 < nblocks .or. start+0.00002 > end) then 	! not enough events/time for flicker
        call warning("insufficientData","Insufficient data (events/timeslots) to perform flickering analysis - aborted")
        nblocks = 1      
      else
!       start = p_time(0)
!       end = p_time(size(p_time)-1) + 0.00001 
        write(errstr,*) "Earliest event time: ",start
        call message(AppMsg,Verbose)
        write(errstr,*) "Latest event time: ",end
        call message(AppMsg,Verbose)
        if (start < p_time(0)-0.1 .or. start > p_time(0)+0.1 .or. &
          end < p_time(size(p_time)-1)-0.1 .or. & 
          end > p_time(size(p_time)-1)+0.1) then 
          call warning("eventsOutOfOrder","Events out of time order - flickering analysis may be in error")
        endif
        timestep = (end - start)/nblocks
      endif
    endif
    !-------------------------------------------------------------
    !	Get cell stuff for PSF (PARAMETER???) and exposure, cellsize, en thresholds
    !-------------------------------------------------------------
    if (instrument == "EMOS1" .or. instrument == "EMOS2") then 
      if (hasAttribute(tab_events,"EXPOSURE")) then 
        exposure = real64Attribute(tab_events,"EXPOSURE")
        hasexposure = .TRUE.
      else if (hasAttribute(tab_events,"TELAPSE")) then 
          exposure = real64Attribute(tab_events,"TELAPSE")
          hasexposure = .TRUE.
      else
        hasexposure = .FALSE.
      endif
    endif
    if (instrument == "EPN") then 
      if (hasAttribute(tab_events,"LIVETIME")) then 
        exposure = real64Attribute(tab_events,"LIVETIME")
        hasexposure = .TRUE.
      else
        hasexposure = .FALSE.
      endif
    endif
    cellsize = intParameter("cellsize")
    en_lo = 1000.0 * realParameter("loenergythresh") !in eV
    en_hi = 1000.0 * realParameter("hienergythresh")

!    if (instrument == "EPN") then !
!      en_lo = en_lo * 0.8	!!!	CAL call wrong by factor of 1.25 - correct for now
!      en_hi = en_hi * 0.8	!!!	???????? OK now
!    endif			  !

    if (en_lo >= en_hi) then 
      call warning("badEnergyThresholds","hienergythresh must be greater than loenergythresh - no Energy filtering performed")
      en_lo = 0
      en_hi = 30000
    endif
    if (instrument /= "EPN") then 
      call CAL_getEbounds(channels,Emin,Emax)
      do i = 0,size(channels)-1
!if (i < 500) then 
!write (*,*) channels(i),Emin(i),Emax(i)
!endif
        if (en_lo >= Emin(i) .and. en_lo < Emax(i)) then 
          en_lo = channels(i)	!PHA
        endif
        if (en_hi > Emin(i) .and. en_hi <= Emax(i)) then 
          en_hi = channels(i)	!PHA
        endif
      enddo
    else ! PN
      en_lo = en_lo / 5.0	!!!	PI to PHA conversion is meaningless
      en_hi = en_hi / 5.0	!!!	w/out cti etc - use canonical  (5 times)
    endif			  !
!write (*,*) "PHA min and max",en_lo,en_hi
    !-------------------------------------------------------------
    !	If MOS, backproject to true image - get VALUER
    !-------------------------------------------------------------
    if (instrument == "EMOS1" .or. instrument == "EMOS2") then 
      call message(AppMsg,Verbose," MOS data - back-projecting patterns onto image")
      im_mos = dataSet("im_mos", Temp)
      call setAttributes(attributable(im_mos),attributable(in_events))
      mosev_map = addArray(im_mos, "PRIMARY", Integer32,  &
             (/nx,ny/), "2-D Histogram")
      call setAttributes(attributable(mosev_map), attributable(tab_events))
      call deleteAttribute(mosev_map,"DATATYPE")
      call deleteAttribute(mosev_map,"EXTVER")
      fromodf = .false.
      projenergy = .false.
      rejectmosbad = .true.      
      call selectevents(tab_events, rejectmosbad, fromodf, nx, ny, en_lo, en_hi, x0, y0)
      !-------------------------------------------------------------
      !	If MOS, and FLICKER - get from selected table flickertime indicees
      !-------------------------------------------------------------
      if (nblocks > 1.1) then               !if to do flickering
!       timecolF = column(tab_events,"TIME",MODIFY)
        timecolF = column(tab_events,"TIME",AccessType)
        p_timeF => real64Data(timecol)
        allocate(mtimeindex(0:nblocks))    !start indecees for times
        mtimeindex(0) = 0
        mtimeindex(nblocks) = numberofrows(tab_events)
        blocknr = 1
        do n = 1, numberofrows(tab_events)-1
          if (p_timeF(n) >= (start + (blocknr * timestep)) .and. &
              p_timeF(n-1) < (start + (blocknr * timestep))) then 
            mtimeindex(blocknr) = n
            blocknr = blocknr + 1
          endif
        enddo
!do n = 0, nblocks
!write (*,*) n, mtimeindex(n)
!enddo
      endif
      !-------------------------------------------------------------
      !	If MOS, get ValueR
      !-------------------------------------------------------------
      allocate(mosevt(numberOfRows(tab_events)))
      call readevents (tab_events, mosevt)
      call buildmosmap (mosevt, mosev_map, projenergy, fromodf, nx, ny, x0, y0)
!      write(errstr,*) "MOS Image array of data type ",dataType(mosev_map)
!      call message(AppMsg,Verbose)
      valueI4 => int32array2data(mosev_map)    !Int32 type I make it!
!      allocate(valueR(x0-1:x0-1+nx-1,y0-1:y0-1+ny-1))
      allocate(valueR(0:nx-1,0:ny-1))
      valueR = real(valueI4)
!do x=0,nx-1
!do y=0,ny-1
!write (*,*) x,y,valueR(x,y)
!enddo
!enddo

    endif
    !-------------------------------------------------------------
    !	If MOS, filter individual flicker images - 3-D array to pass to flicker
    !-------------------------------------------------------------
    if (nblocks > 1.1) then 
    if (instrument == "EMOS1" .or. instrument == "EMOS2") then 
      evtotFmos = 0.0
      allocate(valueFmos(0:nx-1,0:ny-1,0:nblocks-1))
      do n = 0, nblocks-1    
        do x = 0, nx-1
          do y = 0, ny-1
            valueFmos(x,y,n) = 0.0
          enddo
        enddo
      enddo
      do n = 0, nblocks-1    
        call buildmosmap (mosevt(mtimeindex(n)+1:mtimeindex(n+1)), &
                          mosev_map, projenergy, fromodf, nx, ny, x0, y0)
        valueI4 => int32array2data(mosev_map)    !type 4 Int32
        allocate(valueMos(0:nx-1,0:ny-1))
        valueMos = real(valueI4)
        do x = 0, nx-1
          do y = 0, ny-1
            valueFmos(x,y,n) = valueMos(x,y)
            evtotFmos = evtotFmos + valueFmos(x,y,n) 
          enddo
        enddo
      enddo
!write (*,*) "evtotFmos",evtotFmos
    endif
    endif
    !-------------------------------------------------------------
    !	If PN, READ IMAGE - get VALUER
    !-------------------------------------------------------------
!   rxcol = column(tab_events,"RAWX",MODIFY)
!   rycol = column(tab_events,"RAWY",MODIFY)
    rxcol = column(tab_events,"RAWX",AccessType)
    rycol = column(tab_events,"RAWY",AccessType)
    p_rx => int16Data(rxcol)
    p_ry => int16Data(rycol)

    if (instrument == "EPN") then  
!     phacol = column(tab_events,"PHA",MODIFY)
      phacol = column(tab_events,"PHA",AccessType)
      p_pha => int16Data(phacol)
      Npnoutwin = 0 
      NoutErng = 0
      do n = 0, size(p_rx)-1
        !-------------------------------------------------------------
        !ENERGY RANGES??
        !-------------------------------------------------------------
        if (p_pha(n) >= en_lo .and. p_pha(n) <= en_hi) then 	!within energy range
          if (p_rx(n) <= nx+x0-1 .and. p_rx(n) >= x0 .and. &
              p_ry(n) <= ny+y0-1 .and. p_ry(n) >= y0) then 
            valueR(p_rx(n)-x0,p_ry(n)-y0) = valueR(p_rx(n)-x0,p_ry(n)-y0) + 1       
          else
              Npnoutwin = Npnoutwin + 1
          endif
        else
          NoutErng = NoutErng + 1
        endif
      enddo
      if (NoutErng > 0) then 
        write(errstr,*) NoutErng," events (out of ",size(p_rx),") outside energy range - ignored"
        call message(AppMsg,Verbose)
      endif 
      if (Npnoutwin > 0) then 
        call warning("eventsOutOfWindow","Events out of X/Y range - ignored")
      endif 
    endif
    allocate(coltot(0:nx-1))
    allocate(colhot(0:nx-1))
    allocate(colmedian(0:nx-1))
    !-------------------------------------------------------------
    !	GET SIZE, hivalue, lovalue, and STATISTICS stats(value)
    !-------------------------------------------------------------
    npixim = 0
    tot_counts = 0
    lovalue = 9999999.99
    hivalue = -9.999      
    locoltot = 9999.9
    hicoltot = -9.999
    locolmedian = 9999.9
    hicolmedian = -9.999
    do x = 0,nx-1
      coltot(x) = 0.0
      colhot(x) = 0.0
      colmedian(x) = 0.0
      do y = 0,ny-1
        if (valueR(x,y) > hivalue) then 
          hivalue = valueR(x,y)
        endif 
        if (valueR(x,y) < lovalue) then 
          lovalue = valueR(x,y)
        endif
        coltot(x) = coltot(x) + valueR(x,y)
      enddo	! END OF Y LOOP
      if (coltot(x) > hicoltot) then 
        hicoltot = coltot(x)
      endif 
      if (coltot(x) < locoltot) then 
        locoltot = coltot(x)
      endif
    enddo	! END OF X LOOP
    allocate(stats(nint(hivalue)+1))
    allocate(statsY(nint(hivalue)+1))
    allocate(colstats(nint(hicoltot)+1))
    !-------------------------------------------------------------
    !	Clear stats arrays, fill, calculate colmedians
    !-------------------------------------------------------------


    do n = 1, nint(hivalue)+1
      stats(n) = 0        
      statsY(n) = 0
    enddo
    do n = 1, nint(hicoltot)+1
      colstats(n) = 0        
    enddo
    do x = 0,nx-1
      do n = 1, nint(hivalue)+1
        statsY(n) = 0
      enddo
      do y = 0,ny-1
        npixim = npixim + 1
        tot_counts = tot_counts + nint(valueR(x,y))
        stats(nint(valueR(x,y))+1) = stats(nint(valueR(x,y))+1) + 1
        statsY(nint(valueR(x,y))+1) = statsY(nint(valueR(x,y))+1) + 1
      enddo	! END OF Y LOOP
      colstats(nint(coltot(x))+1) = colstats(nint(coltot(x))+1) + 1
      npix = 0
      medianGot = .FALSE.
      do n = 1, nint(hivalue) + 1
        npix = npix + statsY(n) 
        if (.not.medianGot .and. npix >= real(ny)/2) then 
          medianGot = .TRUE. 
          colmedian(x) = n-1
        endif
      enddo
      if (colmedian(x) > hicolmedian) then 
        hicolmedian = colmedian(x)
      endif 
      if (colmedian(x) < locolmedian) then 
        locolmedian = colmedian(x)
      endif
    enddo	! END OF X LOOP
    call message(AppMsg,Verbose,"  ")
    call message(AppMsg,Verbose,"  *** Initial Image Statistics *** ")
    write(errstr,*) "  No. of X pixels: ",nx," No. of Y pixels: ", ny," (Total ",npixim,")"
    call message(AppMsg,Verbose)
    write(errstr,*) "  Lowest value: ",nint(lovalue)," Highest value: ",nint(hivalue) 
    call message(AppMsg,Verbose)
    write(errstr,*) "  Lowest column total: ",nint(locoltot)," Highest column total: ",nint(hicoltot) 
    call message(AppMsg,Verbose)
    write(errstr,*) "  Lowest column median: ",nint(locolmedian)," Highest column median: ",nint(hicolmedian) 
    call message(AppMsg,Verbose)
    write(errstr,*) "  Total No. of counts: ",tot_counts
    call message(AppMsg,Verbose)
    !-------------------------------------------------------------
    !	GET mean, median and mode
    !-------------------------------------------------------------
    call get_mean (stats, colstats, hivalue, hicoltot, npixim, colsearch, mean)
    !-------------------------------------------------------------
    !	get bckgrnd = mean if negative ct/s/pix convert to ct/pix
    !-------------------------------------------------------------
    bckgrnd = realParameter("backgroundrate")  
    if (bckgrnd >= 0.0 .and. .not.hasexposure) then 
      call warning("noExposureFound","No EXPOSURE information available - background = mean")
    endif
    if (bckgrnd < 0.0 .or. .not.hasexposure) then 
      bckgrnd = mean 
    else
      bckgrnd = bckgrnd * exposure
    endif
    write(errstr,*) " Background (ct/pix): ",bckgrnd
    call message(AppMsg,Verbose)

    if (booleanParameter("threshabovebackground")) then 
      usebg = 1
    else 
      usebg = 0
    endif
    usebglo = 0

!-------------------------------------------------------------
!	IF MODE 1 (SEARCH MODE), ENTER 
!-------------------------------------------------------------
    if (mode1) then 
    !-------------------------------------------------------------
    !	Get locolthresh and hicolthresh
    !-------------------------------------------------------------
      locolthresh = realParameter("locolthresh")  
      hicolthresh = realParameter("hicolthresh")  
      if (locolthresh >= hicolthresh) then 
        call error("badThresholds","locolthresh must be less than hicolthresh")
      endif
    !-------------------------------------------------------------
    !	Get lothresh and hithresh 
    !-------------------------------------------------------------
      lothresh = realParameter("lothresh")  
      hithresh = realParameter("hithresh") 
      if (lothresh >= hithresh) then 
        call error("badThresholds","lothresh must be less than hithresh")
      endif
    !-------------------------------------------------------------
    !	Depending on thresholdlabel & columnsearchlabel, convert thresholds
    !-------------------------------------------------------------
      thresholdlabel = ChangeCase(stringParameter("thresholdlabel"),2)
      if (thresholdlabel /= "PEAK" .and. &
          thresholdlabel /= "RATE" .and. &
          thresholdlabel /= "COUNTS") then 
        call error("badThresholdlabel","thresholdlabel incorrect - should be PEAK, RATE or COUNTS")
      endif
      if (.not.hasexposure .and. thresholdlabel == "RATE") then 
        call warning("noExposureFound","No EXPOSURE information available - thresholdlabel=PEAK")
        thresholdlabel = "PEAK"
      endif
      columnsearchlabel = ChangeCase(stringParameter("columnsearchlabel"),2)
      if (columnsearchlabel /= "TOTAL" .and. &
          columnsearchlabel /= "MEDIAN") then 
        call error("badColumnsearchlabel","columnsearchlabel incorrect - should be TOTAL or MEDIAN")
      endif
      if (columnsearchlabel == "TOTAL") then 
        nybg = ny
      else
        nybg = 1
      endif
      if (thresholdlabel == "PEAK") then 
        if (hicolthresh > 100.0 .or. hithresh > 100.0) then 
          call error("badThresholds","for thresholdlabel = PEAK, threshold values must be in range 0 - 100")
        endif
        if (columnsearchlabel == "TOTAL") then 
          locolthresh = hicoltot * locolthresh/100.0
          hicolthresh = hicoltot * hicolthresh/100.0
        else if (columnsearchlabel == "MEDIAN") then 
          locolthresh = hicolmedian * locolthresh/100.0
          hicolthresh = hicolmedian * hicolthresh/100.0
        endif
        lothresh = hivalue * lothresh/100.0
        hithresh = hivalue * hithresh/100.0
      endif
      if (thresholdlabel == "RATE") then 
        write(errstr,*) " Exposure time = ",exposure," sec."
        call message(AppMsg,Verbose)
        if (hasexposure .and. exposure < 1000) then 
          call warning("lowExposure","Exposure time very low - spurious bad pixels may be found (low number statistics)")
        endif   
        write(errstr,*) " Background (ct/s/pix): ",bckgrnd/exposure
        call message(AppMsg,Verbose)
        locolthresh = (exposure * locolthresh) + (usebglo* usebg * nybg * bckgrnd) 
        hicolthresh = (exposure * hicolthresh) + (usebg * nybg * bckgrnd)
        lothresh = (exposure * lothresh) + (usebglo * usebg * bckgrnd)
        hithresh = (exposure * hithresh) + (usebg * bckgrnd)
!write (*,*) 'exposure,hithresh,usebg,bckgrnd'
!write (*,*) exposure,hithresh,usebg,bckgrnd
!write (*,*) 'exposure,hicolthresh,usebg,bckgrnd,nybg'
!write (*,*) exposure,hicolthresh,usebg,bckgrnd,nybg
      endif
      if (thresholdlabel == "COUNTS") then  
        locolthresh = locolthresh + (usebglo* usebg * nybg * bckgrnd)
        hicolthresh = hicolthresh + (usebg * nybg * bckgrnd)
        lothresh = lothresh + (usebglo * usebg * bckgrnd)
        hithresh = hithresh + (usebg * bckgrnd)
      endif
      psfthresh = realParameter("narrowerthanpsf")
      !-------------------------------------------------------------
      !	Clear stats for new stats
      !-------------------------------------------------------------
      npixim = 0
      tot_counts = 0
      do n = 1, nint(hivalue)+1
        stats(n) = 0
      enddo
      do n = 1, nint(hicoltot)+1
        colstats(n) = 0
      enddo
      lovalue = 9999999.99
      hivalue = -9.999    
      yextentfound = .FALSE.
      extent = 0  
      !-------------------------------------------------------------
      !	column search?
      !-------------------------------------------------------------
      if (colsearch) then 
      call message(AppMsg,Sparse," ")
      call message(AppMsg,Sparse,"  *** Badpixfind Mode1 *** - Searching for hot/dead columns")
        !-------------------------------------------------------------
        !	Loop through columns for hot and dead column search
        !-------------------------------------------------------------
        do x = 0, nx-1
          if ((columnsearchlabel == "TOTAL" .and. coltot(x) < locolthresh) .or. &
              (columnsearchlabel == "MEDIAN" .and. colmedian(x) < locolthresh)) then
            Nbpix1 = Nbpix1 + 1
            Nbpix = Nbpix + 1
            a_rawX(Nbpix) = x + x0
            a_rawY(Nbpix) = y0
            a_badPixType(Nbpix) = 3
            a_yextent(Nbpix) = ny
            write(errstr,*) "  Dead column found at RAWX of ",x+x0
            call message(AppMsg,Verbose)
            do y = 0, ny-1
              good(x,y) = 0
            enddo
          endif
          if ((columnsearchlabel == "TOTAL" .and. coltot(x) > hicolthresh) .or. &
              (columnsearchlabel == "MEDIAN" .and. colmedian(x) > hicolthresh)) then
                !hot column
            !------------------------------------------
            ! Really hot? compare PSF - hot columns vs OOTs
            !------------------------------------------
            ishot = .TRUE. 
            if (cellsize > 0.5) then 
              call hotcolcheck(psfthresh, coltot, colmedian, x, y, x0, y0, nx, ny, cellsize, ccdnode, bckgrnd, &
                            ishot, columnsearchlabel)
            endif
            if (ishot) then 
              colhot(x) = 1.0
              Nbpix1 = Nbpix1 + 1
              Nbpix = Nbpix + 1
              a_rawX(Nbpix) = x + x0
              a_rawY(Nbpix) = y0
              a_badPixType(Nbpix) = 1
              a_yextent(Nbpix) = ny
              write(errstr,*) "  Hot column found at RAWX of ",x+x0
              call message(AppMsg,Verbose)
              do y = 0, ny-1
                good(x,y) = 0
              enddo
            endif
          endif
        enddo
      endif
      if (locoltot <= nint(locolthresh)) then 
        locoltot = nint(locolthresh)
      endif
      if (hicoltot >= nint(hicolthresh)) then 
        hicoltot = nint(hicolthresh)
      endif
      Nbpixsave = Nbpix
      Nbpix1save = Nbpix1
      !-------------------------------------------------------------
      !	Quick `too many deads' loop
      !-------------------------------------------------------------
      do x = 0, nx-1
        do y = 0, ny-1
          if (valueR(x,y) < lothresh) then 		!!! Dead
            Nbpix1 = Nbpix1 + 1
            Nbpix = Nbpix + 1
            a_rawX(Nbpix) = x + x0
            a_rawY(Nbpix) = y + y0
            a_badPixType(Nbpix) = 3
              ! check for yextent
            if (Nbpix == 1) then 
              a_yextent(Nbpix) = 1
            endif
            if (Nbpix >= 2) then 
              if (a_rawX(Nbpix) == a_rawX(Nbpix-1) .and. &
                  a_rawY(Nbpix) == a_rawY(Nbpix-1)+1+extent .and. &
                  a_badPixType(Nbpix) == a_badPixType(Nbpix-1)) then 	!extent
                yextentfound = .TRUE.
                extent = extent + 1
                Nbpix = Nbpix - 1
                Nbpix1 = Nbpix1 - 1
              else if (a_rawX(Nbpix) /= a_rawX(Nbpix-1) .or. &
                       a_rawY(Nbpix) /= a_rawY(Nbpix-1)+1+extent .or. &
                       a_badPixType(Nbpix) /= a_badPixType(Nbpix-1)) then !extent ended
                if (yextentfound) then
                  a_yextent(Nbpix-1) = extent + 1
                  yextentfound = .FALSE.
                  extent = 0
                endif
                if (.not.yextentfound) then
                  a_yextent(Nbpix) = 1
                endif
              endif
            endif 
          endif
          if (Nbpix > max-1) then 
            write (errstr,*) "The setting of `lothresh' has found well over", max, &
                             "dead pixels. Note: Your dataset may contain many ", &
                             "zeros, in which case, a dead pixel search is ", &
                             "problematic. Please try again."
            call error("badLothresh")
          endif
        enddo
      enddo
      !-------------------------------------------------------------
      !	MAIN Loop through pixels for hot and dead pixels search
      !-------------------------------------------------------------
      Nbpix = Nbpixsave
      Nbpix1 = Nbpix1save
      yextentfound = .FALSE.
      extent = 0  
      call message(AppMsg,Sparse," ")
      call message(AppMsg,Sparse,"  *** Badpixfind Mode1 *** - Searching for hot/dead pixels")
      if (psfthresh < 1.1) then 
        call warning("findRealSources","chosen narrowerthanpsf parameter very low - real sources may be found")       
      endif
      if (psfthresh < 0.0001) then 
        call message(AppMsg,Sparse," Note - narrowerthanpsf of zero chosen - no PSF comparison made")
      endif
      do x = 0, nx-1
        do y = 0, ny-1
          !-------------------------------------------------------------
          !	Dead
          !-------------------------------------------------------------
          if (valueR(x,y) < lothresh) then 		!!! Dead
            Nbpix1 = Nbpix1 + 1
            Nbpix = Nbpix + 1
            a_rawX(Nbpix) = x + x0
            a_rawY(Nbpix) = y + y0
            a_badPixType(Nbpix) = 3
              ! check for yextent
            if (Nbpix == 1) then 
              write(errstr,*) "  Dead pixel (counts = ",nint(valueR(x,y)),") found at",x+x0,",",y+y0
              good(x,y) = 0
              call message(AppMsg,Verbose)
              a_yextent(Nbpix) = 1
            endif
            if (Nbpix >= 2) then 
              if (a_rawX(Nbpix) == a_rawX(Nbpix-1) .and. &
                  a_rawY(Nbpix) == a_rawY(Nbpix-1)+1+extent .and. &
                  a_badPixType(Nbpix) == a_badPixType(Nbpix-1)) then 		!extent
                yextentfound = .TRUE.
                good(x,y) = 0
                extent = extent + 1
                Nbpix = Nbpix - 1
                Nbpix1 = Nbpix1 - 1
              else if (a_rawX(Nbpix) /= a_rawX(Nbpix-1) .or. &
                       a_rawY(Nbpix) /= a_rawY(Nbpix-1)+1+extent .or. &
                       a_badPixType(Nbpix) /= a_badPixType(Nbpix-1)) then 	!extent ended
                if (yextentfound) then
                  a_yextent(Nbpix-1) = extent + 1
                  write (errstr,*) "    starts column of extent ",extent + 1," pixels"
                  call message(AppMsg,Verbose)
                  yextentfound = .FALSE.
                  extent = 0
                endif
                if (.not.yextentfound) then
                  a_yextent(Nbpix) = 1
                  write (errstr,*) "  Dead pixel (counts = ",nint(valueR(x,y)),") found at",x+x0,",",y+y0
                  good(x,y) = 0
                  call message(AppMsg,Verbose)
                endif
              endif
            endif 
          !-------------------------------------------------------------
          !	Hot  
          !-------------------------------------------------------------
          else if (valueR(x,y) > hithresh) then 		!!! Hot
            !-------------------------------------------------------------
            !	Really hot? Compare psf  
            !-------------------------------------------------------------
            ishot = .TRUE.
            if (cellsize > 0.5 .and. psfthresh>=0.0001) then 
!write (*,*) "into hotcheck",x,y
              call hotcheck(psfthresh, valueR, x, y, x0, y0, nx, ny, cellsize, ccdnode, bckgrnd, &
                            ishot, fracGTPSF, good)
!write (*,*) "out of hotcheck",x,y
            endif
            if (ishot) then 
              Nbpix1 = Nbpix1 + 1
              Nbpix = Nbpix + 1
              a_rawX(Nbpix) = x + x0
              a_rawY(Nbpix) = y + y0
              a_badPixType(Nbpix) = 1
                ! check for yextent
              if (Nbpix == 1) then 
                write(expression,110) nint(valueR(x,y)),fracGTPSF,x+x0,y+y0
 110            format(" Hot pixel (counts=",I6," PSFfac=",F7.3,") found at ",I3,",",I3," ") 
                good(x,y) = 0
                write(errstr,*) trim(expression)
                call message(AppMsg,Verbose)
                a_yextent(Nbpix) = 1
              endif
              if (Nbpix >= 2) then 
                if (a_rawX(Nbpix) == a_rawX(Nbpix-1) .and. &
                    a_rawY(Nbpix) == a_rawY(Nbpix-1)+1+extent .and. &
                    a_badPixType(Nbpix) == a_badPixType(Nbpix-1)) then 		!extent
                  yextentfound = .TRUE.
!write (*,*) x,y,extent
                  good(x,y) = 0
                  extent = extent + 1
                  Nbpix = Nbpix - 1
                  Nbpix1 = Nbpix1 - 1
                else if (a_rawX(Nbpix) /= a_rawX(Nbpix-1) .or. &
                         a_rawY(Nbpix) /= a_rawY(Nbpix-1)+1+extent .or. &
                         a_badPixType(Nbpix) /= a_badPixType(Nbpix-1)) then 	!extent ended
                  if (yextentfound) then
                    a_yextent(Nbpix-1) = extent + 1
                    write (errstr,*) "    starts column of extent ",extent + 1," pixels"
                    call message(AppMsg,Verbose)
                    yextentfound = .FALSE.
                    extent = 0
                  endif
                  if (.not.yextentfound) then
                    a_yextent(Nbpix) = 1
                    write(expression,110) nint(valueR(x,y)),fracGTPSF,x+x0,y+y0
                    good(x,y) = 0
                    write(errstr,*) trim(expression)
                    call message(AppMsg,Verbose)
                  endif
                endif
              endif 
            endif !end ishot
          !-------------------------------------------------------------
          !	Else pixel x/y is OK
          !-------------------------------------------------------------
          else if (valueR(x,y) >= lothresh .and. valueR(x,y) <= hithresh .and. &
                   colhot(x) < 0.5) then 
          !-------------------------------------------------------------
          !	Get mode1 stats excluding above hot and dead pixels
          !-------------------------------------------------------------
            npixim = npixim + 1
            tot_counts = tot_counts + nint(valueR(x,y))
            stats(nint(valueR(x,y))+1) = stats(nint(valueR(x,y))+1) + 1
            if (valueR(x,y) > hivalue) then 
              hivalue = valueR(x,y)
            endif 
            if (valueR(x,y) < lovalue) then 
              lovalue = valueR(x,y)
            endif
          endif
        enddo	! END OF XY LOOP
      enddo	!
      if (Nbpix == 0) then 		!no bad pixels found
        call message(AppMsg,Sparse,"No hot or dead pixels found - thresholds OK?")
      endif
      !-------------------------------------------------------------
      !	Close yextent waiting (if exists)
      !-------------------------------------------------------------
      if (yextentfound) then
        a_yextent(Nbpix) = extent + 1
        write (errstr,*) "    starts column of extent ",extent + 1," pixels"
        call message(AppMsg,Verbose)
        yextentfound = .FALSE.
        extent = 0
      endif
      if (colsearch) then 
        call message(AppMsg,Verbose,"  ")
        call message(AppMsg,Verbose,"  *** Statistics after hot/dead pixel/column search (Mode1) ***")
      else
        call message(AppMsg,Verbose,"  ")
        call message(AppMsg,Verbose,"  *** Statistics after hot/dead pixel search (Mode1) ***")
      endif
      write (errstr,*) "  No. of good pixels ",npixim
      call message(AppMsg,Verbose)
      if (npixim == 0) then
        call warning("noGoodPixsFound","No good pixels found - thresholds OK?")
      else
        write (errstr,*) "  New lowest value: ",nint(lovalue)," New highest value: ",nint(hivalue) 
        call message(AppMsg,Verbose)
        write (errstr,*) "  Total No. of good counts: ",tot_counts
        call message(AppMsg,Verbose)
        !-------------------------------------------------------------
        !	GET new mean, median and mode
        !-------------------------------------------------------------
        call get_mean (stats, colstats, hivalue, hicoltot, npixim, colsearch, mean)
      endif
!-------------------------------------------------------------
!	FLICKER
!-------------------------------------------------------------
      if (nblocks > 1.1) then 
        call message(AppMsg,Sparse,"  ")
        call message(AppMsg,Sparse,"  *** Badpixfind Mode1 *** - Searching for flickering pixels")
        call flicker(nx, ny, start, rxcol, rycol, timecol, instrument, &
                     x0, y0, Nbpix, a_rawX, a_rawY, a_badPixType, a_yextent, &
                     nblocks, timestep, valueFmos, phacol, en_lo, en_hi, good)
      else
        call message(AppMsg,Verbose,"flickertimesteps of 1 chosen - not searching for flickering pixels  ")
      endif

    endif	! END MODE1 CONDITION
!-------------------------------------------------------------
!	IF MODE 2 (FLAG MODE), ENTER 
!-------------------------------------------------------------
    if (mode2) then 
      call message(AppMsg,Sparse,"  ")
      call message(AppMsg,Sparse,"  *** Badpixfind Mode2 *** - User-flagging of bad pixels")
      bpixOK = .TRUE. 
      Nbpix2 = parameterCount("rawxlist")
      !-------------------------------------------------------------
      !	Loop through mode 2 pixels
      !-------------------------------------------------------------
      do i = 1, Nbpix2
        Nbpix = Nbpix + 1
        a_rawX(Nbpix) = intParameter("rawxlist",i-1)
        a_rawY(Nbpix) = intParameter("rawylist",i-1)
        a_badPixType(Nbpix) = intParameter("typelist",i-1)
        a_yextent(Nbpix) = intParameter("yextentlist",i-1)
      !-------------------------------------------------------------
      ! Is pixel allowed
      !-------------------------------------------------------------
        if (instrument == "EPN") then 
          if (a_rawX(Nbpix) >= 1 .and. a_rawX(Nbpix) <= 64 .and. &
              a_rawY(Nbpix) >= 1 .and. a_rawY(Nbpix) <= 200 .and. &
              a_badPixType(Nbpix) >= 1 .and. a_badPixType(Nbpix) <= 5 .and. &
              (a_yextent(Nbpix) + a_rawY(Nbpix)) <= 201 ) then
            bpixOK = .TRUE. 
          else
            bpixOK = .FALSE.  
          endif
        endif
        if (instrument == "EMOS1" .or. instrument == "EMOS2") then 
          if (a_rawX(Nbpix) >= 1 .and. a_rawX(Nbpix) <= 600 .and. &
              a_rawY(Nbpix) >= 1 .and. a_rawY(Nbpix) <= 600 .and. &
              a_badPixType(Nbpix) >= 1 .and. a_badPixType(Nbpix) <= 5 .and. &
              a_yextent(Nbpix) + a_rawY(Nbpix) <= 601 ) then
            bpixOK = .TRUE. 
          else
            bpixOK = .FALSE.  
          endif
        endif
      !-------------------------------------------------------------
      !	End loop through mode 2 pixels - END MODE2
      !-------------------------------------------------------------
        if (.not. bpixOK) then
          call error("userListValuesOutOfRange","userflagbadpix list input values invalid")
        endif
      enddo    
    endif  !end mode2
    !--------------------------------------------------------
    ! CLEAN?CHECK?PURGE?? No...
    !-------------------------------------------------------------
    call message(AppMsg,Sparse,"  ")
    call message(AppMsg,Sparse,"  *** Checking final badpixfind list ***")
    warnflag = .FALSE.
    do n = 1, Nbpix - 1
      do i = n+1, Nbpix
        if (a_rawX(n) == a_rawX(i) .and. a_rawY(n) == a_rawY(i)) then !found
          warnflag = .TRUE.              
          write (errstr,*) " multi-entry pixel found at ",a_rawX(n),",",a_rawY(n)
          call message(AppMsg,Verbose)
        endif
      enddo
    enddo
    if (warnflag) then 
        call message(AppMsg,Sparse,"Note - pixels found with more than one entry")
    endif
    !--------------------------------------------------------
    ! FINAL STATS
    !-------------------------------------------------------------
    if (npixim > 0) then 
      npixim = 0
      tot_counts = 0
      do n = 1, nint(hivalue)+1
        stats(n) = 0
      enddo
      lovalue = hivalue
      hivalue = -1 * hivalue
      do x = 0,nx-1
        do y = 0,ny-1
          bpixOK = .TRUE.
          do n = 1,Nbpix
            if (bpixOK) then 
              if (x+x0 /= a_rawX(n) .or. y+y0 < a_rawY(n) .or. &
                  y+y0 > a_rawY(n) + a_yextent(n) - 1) then 
                bpixOK = .TRUE.
              else
                bpixOK = .FALSE.
              endif
            else if (.not.bpixOK) then
              bpixOK = .FALSE.
            endif
          enddo
          if (bpixOK) then
            if (valueR(x,y) > hivalue) then 
              hivalue = valueR(x,y)
            endif 
            if (valueR(x,y) < lovalue) then 
              lovalue = valueR(x,y)
            endif
            npixim = npixim + 1
            tot_counts = tot_counts + nint(valueR(x,y))
            stats(nint(valueR(x,y))+1) = stats(nint(valueR(x,y))+1) + 1
          endif
        enddo	! END OF XY LOOP
      enddo	!
      call message(AppMsg,Verbose,"  ")
      call message(AppMsg,Verbose,"  *** Final Statistics ***")
      write (errstr,*) "  No. of good pixels ",npixim
      call message(AppMsg,Verbose)
      if (npixim == 0) then
        call warning("noGoodPixsFound","No good pixels found - thresholds OK?")
      else
        write (errstr,*) "  New lowest value: ",nint(lovalue)," New highest value: ",nint(hivalue) 
        call message(AppMsg,Verbose)
        write (errstr,*) "  Total No. of good counts: ",tot_counts
        call message(AppMsg,Verbose)
        !-------------------------------------------------------------
        !	GET FINAL mean, median and mode
        !-------------------------------------------------------------
        call get_mean (stats, colstats, hivalue, hicoltot, npixim, colsearch, mean)
      endif
    endif
!-------------------------------------------------------------
!	CREATE OUTPUT MASK
!-------------------------------------------------------------
    if (booleanParameter("withbadpixmap")) then
      Nmapnear = intParameter("mappixcellsize") 	
      if (instrument == "EPN") then 
        imageDim(1) = EPN_MAX_X
        imageDim(2) = EPN_MAX_Y
!        write(outmapname,'(a,i2.2,a)') 'BPXFmapPN_',ccdid,'.fits'
      else ! MOS
        imageDim(1) = EMOS_MAX_X
        imageDim(2) = EMOS_MAX_Y
!       write(outmapname,'(a,i2.2,a)') 'BPXFmapMOS_',ccdid,'.fits'
      endif

      outmapname = stringParameter("badpixmap")
      outmap = dataSet(outmapname,Create)
      map = addArray(outmap, "PRIMARY",Integer8, imageDim)
      map_arrayP => int8Array2Data(map)
      call message(AppMsg,Verbose,"Creating output badpixfind map...")
      call message(AppMsg,Verbose," Including uplinked CCF bad pixels...")

!write (*,*) nx,ny,x0,y0
!write (*,*) EPN_MAX_X,EPN_MAX_Y

      if (instrument == "EPN") then 
        PNmap_array(1:EPN_MAX_X,1:EPN_MAX_Y) = 0
        PNmap_array(x0:x0+nx-1,y0:y0+ny-1) = 1
        if (Nbpix + nUp > 0.5) then

          do n = 1, Nbpix	! FOUND pixels
            do yext = 1,a_yextent(n)
              PNmap_array(a_rawX(n),a_rawY(n)+yext-1) = 0
              !  Neighbours
              do x = a_rawX(n)-Nmapnear,a_rawX(n)+Nmapnear
                do y = a_rawY(n)+yext-1-Nmapnear,a_rawY(n)+yext-1+Nmapnear
                  if (x>=1 .and. x<=EPN_MAX_X .and. y>=1 .and. y<=EPN_MAX_Y) then 
                    PNmap_array(x,y) = 0
                  endif
                enddo
              enddo
            enddo
          enddo

          do n = 0, nCCF-1		! UPLINKED pixels (w/filter)
            if (UpUp(n)) then 
              do yext = 1,UpYext(n)
                PNmap_array(UpX(n),UpY(n)+yext-1) = 0
                !  Neighbours
                do x = UpX(n)-Nmapnear,UpX(n)+Nmapnear
                  do y = UpY(n)+yext-1-Nmapnear,UpY(n)+yext-1+Nmapnear
                    if (x>=1 .and. x<=EPN_MAX_X .and. y>=1 .and. y<=EPN_MAX_Y) then 
                      PNmap_array(x,y) = 0
!if (UpX(n)==42 .and. UpY(n)==76) then 
!write (*,*) n,UpX(n),UpY(n),yext,Nmapnear,x,y,PNmap_array(x,y)
!endif
                    endif
                  enddo
                enddo
              enddo
            endif
          enddo
        endif

        if (booleanParameter("withfovmask")) then 
          call CAL_getFOVmap(FOVmap)
          do x = 1,EPN_MAX_X
            do y = 1,EPN_MAX_Y
              if (FOVmap(x-1,y-1)==0) PNmap_array(x,y) = 0
            enddo
          enddo
        endif

      else ! MOS	|FOUND
        MOSmap_array(1:EMOS_MAX_X,1:EMOS_MAX_Y) = 0
        MOSmap_array(x0:x0+nx-1,y0:y0+ny-1) = 1
        if (Nbpix + nUp > 0.5) then

          do n = 1, Nbpix
            do yext = 1,a_yextent(n)
              MOSmap_array(a_rawX(n),a_rawY(n)+yext-1) = 0
              !  Neighbours
              do x = a_rawX(n)-Nmapnear,a_rawX(n)+Nmapnear
                do y = a_rawY(n)+yext-1-Nmapnear,a_rawY(n)+yext-1+Nmapnear
                  if (x>=1 .and. x<=EMOS_MAX_X .and. y>=1 .and. y<=EMOS_MAX_Y) then 
                    MOSmap_array(x,y) = 0
                  endif
                enddo
              enddo
            enddo
          enddo

          do n = 0, nCCF-1		!UPLINKED w/filter
            if (UpUp(n)) then 
              do yext = 1,UpYext(n)
                MOSmap_array(UpX(n),UpY(n)+yext-1) = 0
                !  Neighbours
                do x = UpX(n)-Nmapnear,UpX(n)+Nmapnear
                  do y = UpY(n)+yext-1-Nmapnear,UpY(n)+yext-1+Nmapnear
                    if (x>=1 .and. x<=EMOS_MAX_X .and. y>=1 .and. y<=EMOS_MAX_Y) then 
                      MOSmap_array(x,y) = 0
                    endif
                  enddo
                enddo
              enddo
            endif
          enddo

          if (booleanParameter("withfovmask")) then 
            call CAL_getFOVmap(FOVmap)
            do x = 1,EMOS_MAX_X
              do y = 1,EMOS_MAX_Y
                if (FOVmap(x-1,y-1)==0) MOSmap_array(x,y) = 0
              enddo
            enddo
          endif

        endif
      endif
  
      goodmappix = 0
      if (instrument == "EPN") then 
        do x=1,EPN_MAX_X
          do y=1,EPN_MAX_Y
            if (PNmap_array(x,y) == 1) goodmappix = goodmappix + 1
          enddo
        enddo
        write (errstr,*) "Map created (",EPN_MAX_X,"x",EPN_MAX_Y,") - ",goodmappix," pixels set to good"
      else !MOS
        do x=1,EMOS_MAX_X
          do y=1,EMOS_MAX_Y
            if (MOSmap_array(x,y) == 1) goodmappix = goodmappix + 1
          enddo
        enddo
        write (errstr,*) "Map created (",EMOS_MAX_X,"x",EMOS_MAX_Y,") - ",goodmappix," pixels set to good"
      endif
      call message(AppMsg,Sparse)
      if (booleanParameter("withfovmask")) then 
        write (errstr,*) "FOV masked out in map"
        call message(AppMsg,Sparse)
      endif  

      if (instrument == "EPN") then 
        map_arrayP = PNmap_array
      else !MOS
        map_arrayP = MOSmap_array
      endif
      !-------------------------------------------------------------
      !	WRITE attributes to map (event file attributes, GOODPIX) 
      !-------------------------------------------------------------
      call setAttributes(attributable(outmap),attributable(tab_events))
      call setAttribute(outmap,"GOODPIX",goodmappix,"","Number of good map pixels")
      call release(outmap)
    endif 
!-------------------------------------------------------------
!	CREATE BADPIX EXTENSION
!-------------------------------------------------------------
    write (errstr,*) "Creating file (",trim(filename),"): Number of entries: ", Nbpix
    call message(AppMsg,Sparse)
    if (Nbpix > 0.5) then
      call message(AppMsg,Verbose,"RAWX  RAWY  TYPE  EXTENT")
      do n = 1, Nbpix
        write (errstr,'(I4,I6,I6,I8)') a_rawX(n),a_rawY(n),a_badPixType(n),a_yextent(n)
        call message(AppMsg,Verbose)
      enddo
    endif

    tab_bpix = addTable(out_bpix,"BADPIX",Nbpix)
    rawX = addcolumn(tab_bpix,"RAWX",Integer16,"pixels") 
    rawY = addcolumn(tab_bpix,"RAWY",Integer16,"pixels") 
    badPixType = addcolumn(tab_bpix,"TYPE",Integer16,"") 
    yextent = addcolumn(tab_bpix,"YEXTENT",Integer16,"pixels") 

    p_rawX => Int16Data(rawX)
    p_rawY => Int16Data(rawY)
    p_badPixType => Int16Data(badPixType)
    p_yextent => Int16Data(yextent)

    p_rawX = 0
    p_rawY = 0 
    p_badPixType = 0
    p_yextent = 0

    p_rawX = a_rawX(1:Nbpix)
    p_rawY = a_rawY(1:Nbpix)
    p_badPixType = a_badPixType(1:Nbpix)
    p_yextent = a_yextent(1:Nbpix)
!------------------------------------------------------------
!	ADD A FEW ATTRIBUTES
!------------------------------------------------------------
    call setAttribute(tab_bpix,"TELESCOP",stringAttribute(tab_events,"TELESCOP"), &
                      "Telescope (mission) name")
    call setAttribute(tab_bpix,"INSTRUME",stringAttribute(tab_events,"INSTRUME"), &
                      "Instrument name")
    call setAttribute(tab_bpix,"CCDID",int8Attribute(tab_events,"CCDID"),"", &
                      "ccd in use")
    call setAttribute(tab_bpix,"EXP_ID",expid,"Exposure identifier")
    call setAttribute(tab_bpix,"OBS_ID",obsid,"Observation identifier")
    if (instrument == "EPN") then 
      call setAttribute(tab_bpix,"QUADRANT",int8Attribute(tab_events,"QUADRANT"), &
                      "","quadrant in use")
    endif 
    if (instrument == "EMOS1" .or. instrument .eq. "EMOS2") then 
      call setAttribute(tab_bpix,"CCDNODE",int8Attribute(tab_events,"CCDNODE"), &
                      "","ccd node")
    endif
    call setAttribute(tab_bpix,"WINDOWX0",x0,"","X coordinate of bottom left corner of window")
    call setAttribute(tab_bpix,"WINDOWY0",y0,"","Y coordinate of bottom left corner of window")
    call setAttribute(tab_bpix,"WINDOWDX",nx,"","size, along X axis, of window")
    call setAttribute(tab_bpix,"WINDOWDY",ny,"","size, along Y axis, of window")

!------------------------------------------------------------
!	ADD HISTORY (can put more information in)
!------------------------------------------------------------
    history = "badpixfind file includes: "
    call addHistory(out_bpix,history)
    if (mode1) then
      write(history,'(a,i4,a)') "Mode1(searchbadpix): ",Nbpix1," found bad pixels (or columns)"
      call addHistory(out_bpix,history)
    endif
    if (mode2) then
      write(history,'(a,i4,a)') "Mode2(userflagbadpix): ",Nbpix2," user-flagged bad pixels (or columns)"
      call addHistory(out_bpix,history)
    endif
!------------------------------------------------------------
!	RELEASE FILES
!------------------------------------------------------------
!    if (instrument == "EMOS1" .or. instrument == "EMOS2") then 
!      deallocate(mosevt)
!    endif
!    call release(rawX)
!    call release(rawY)
!    call release(badPixType)
!    call release(yextent)
    call release(tab_bpix)
    call release(out_bpix)
    if (instrument == "EMOS1" .or. instrument == "EMOS2") then
      call release(mosev_map)
      call release(im_mos)
    endif
    call release(tab_events)
    call release(in_events)
!------------------------------------------------------------
!	END
!----------------------------------------------------------- 
!do x=0,nx-1
!do y=0,ny-1
!if (good(x,y)==0 .and. y>9) then 
!write (*,*) x,y,good(x,y)
!endif
!enddo
!enddo
 end subroutine badpixfind
!------------------------------------------------------------
!
!	SUBROUTINES
!
!----------------------------------------------------------- 
    subroutine get_mean (stats, colstats, hivalue, hicoltot, npixim, &
                         colsearch, mean)

    implicit none 

    integer(int32), dimension(:) :: stats, colstats
    integer		:: sum, npix, median, mode, n, npixim, histats
    real(kind=double)   :: hivalue, hicoltot, mean
    logical 		:: mediangot, colsearch

    sum = 0 
    npix = 0
    mean = -9.9
    median = -9
    medianGot = .FALSE.
    histats = -9
    do n = 1, nint(hivalue) + 1
      if (stats(n) > 0.5) then 
        if (stats(n) > 1.5) then 
          write (errstr,*) '    ',stats(n),' pixels found with ',n-1,' counts'
          call message(AppMsg,Noisy)
        else
          write (errstr,*) '    ',stats(n),' pixel found with ',n-1,' counts'
          call message(AppMsg,Noisy)
        endif
      endif
      sum = sum + ((n-1) * stats(n))
      npix = npix + stats(n)
      if (.not.medianGot .and. npix >= real(npixim)/2) then 
        medianGot = .TRUE. 
        median = n-1
      endif
      if (stats(n) > histats) then
        histats = stats(n)
        mode = n-1
      endif
    enddo
    mean = real(sum)/real(npixim)
    write (errstr,*) "    Mean value  : ",mean
    call message(AppMsg,Verbose)
    write (errstr,*) "    Median value: ",median
    call message(AppMsg,Verbose)
    write (errstr,*) "    Mode value  : ",mode
    call message(AppMsg,Verbose)

    if (colsearch) then 
      do n = 1, nint(hicoltot) + 1
        if (colstats(n) > 0.5) then 
          if (colstats(n) > 1.5) then 
            write (errstr,*) '    ',colstats(n),' columns found with ',n-1,' total counts'
            call message(AppMsg,Noisy)
          else
            write (errstr,*) '    ',colstats(n),' column found with ',n-1,' total counts'
            call message(AppMsg,Noisy)
          endif
        endif
      enddo
    endif

    end subroutine get_mean
  !---------------------------------------------------------------------
  !
  ! MOS BACKPROJECTING ROUTINES
  !
  !---------------------------------------------------------------------
  subroutine selectevents(ev_tab, rejectbad, fromodf, nx, ny, en_lo, en_hi, x0, y0)

! ev_tab : Handle to the input table
! rejectbad  : Reject the events with rejection flag set when projecting ?
! fromodf    : Is this an events file straight from the ODF ?

    type(TableT), intent(inout) :: ev_tab
    logical, intent(in)         :: rejectbad, fromodf

    character(len=140) :: expression, reject
    integer :: nrow1, nx, ny, x0, y0
    integer(kind=int32) :: testqual
    real(kind=double)    :: en_lo, en_hi

!    write(errstr,*) "Number of events in MOS input file: ", numberOfRows(ev_tab)
!    call message(AppMsg,Verbose)

! Make the expression for initFilter
! The selection on position is different before emevents
! because RAWX,RAWY are offset by dx1+1, dy1+1 there

!write (*,*) 'x0,y0,nx,ny'
!write (*,*) x0,y0,nx,ny
    if (fromodf) then
!       write(expression,100)  dx1+1, nx+dx1+2, dy1+1, ny+dy1+2
    else
       write(expression,100)  x0-1, x0+nx, y0-1, y0+ny, en_lo, en_hi
    endif
!100   format("(RAWX-",I3,")*(",I3,"-RAWX)>0 && (RAWY-",I3,")*(",I3,"-RAWY)>0")
 
 100   format("(RAWX-",I3,")*(",I3,"-RAWX)>0 && (RAWY-",I3,")*(",I3,"-RAWY)>0 && (ENERGYE1)>=",F7.1," && (ENERGYE1)<=",F7.1," ")
    
    if (rejectbad) then
       testqual = EVATT_EMOS_REJECTION_MASK
       if (iand(testqual,EVATT_OUT_OF_FOV) > 0)  testqual = testqual - EVATT_OUT_OF_FOV
       write(reject,'("(FLAG & 0x",Z8.8,")==0")') testqual
       expression = trim(expression) // " && " // reject
    endif
!     write(errstr,*) "Call initFilter with expression ", expression
!     call message(AppMsg,Verbose)
    call initFilter( expression )

! Filter ev_tab

    nrow1 = doFilter( ev_tab )
    if (nrow1 < 1) then
       call warning("noEventsinERange","No events within requested Energy range")
    else
!       write(errstr,*) "Number of good events in MOS input file: ", nrow1
!       call message(AppMsg,Verbose)
    endif

  end subroutine selectevents
  !---------------------------------------------------------------------
  subroutine readevents(ev_tab, evt) 		!Jean

! ev_tab : Handle to the input table
! evt    : Array of event structure

    type(TableT), intent(in) :: ev_tab
    type(sas_evt), dimension(:),intent(out) :: evt

! Name of the columns

    character(len=8), parameter :: rawx = "RAWX    ", rawy = "RAWY    ", &
                                   ene1 = "ENERGYE1", ene2 = "ENERGYE2", &
                                   patt = "PATTERN "

    real(kind=double), dimension(:), allocatable :: timebuf

    allocate(timebuf(numberOfRows(ev_tab)))
    timebuf = 0.d0

! Only RAWX, RAWY, PATTERN, ENERGYE1 and ENERGYE2 are useful

    call copy_block(ev_tab, rawx, timebuf)
    evt%rawx = int(timebuf+sign(0.5D0,timebuf),int16)
    call copy_block(ev_tab, rawy, timebuf)
    evt%rawy = int(timebuf+sign(0.5D0,timebuf),int16)
    call copy_block(ev_tab, patt, timebuf)
    evt%pattern = int(timebuf+sign(0.5D0,timebuf),int8)
    call copy_block(ev_tab, ene1, timebuf)
    evt%e1 = int(timebuf+sign(0.5D0,timebuf),int16)
    call copy_block(ev_tab, ene2, timebuf)
    evt%e2 = int(timebuf+sign(0.5D0,timebuf),int16)

    deallocate(timebuf)

  end subroutine readevents
  !---------------------------------------------------------------------
  subroutine copy_block(ev_tab, colname, buffer)

! ev_tab  : handle to the input table for the DAL
! colname : column name
! buffer  : output array (double)

    type(TableT),  intent(in)  :: ev_tab
    character(len=*), intent(in) :: colname
    real(kind=double), dimension(:), intent(out) :: buffer

    type(ColumnT) :: in_col
    integer :: coltype

! Possible types of columns

    real(kind=double),   dimension(:), pointer   :: dbledata
    real(kind=single),   dimension(:), pointer   :: sngldata
    integer(kind=int32), dimension(:), pointer   :: longdata
    integer(kind=int16), dimension(:), pointer   :: intgdata
    integer(kind=int8),  dimension(:), pointer   :: bytedata

! Read input column

    in_col  = column(ev_tab, colname, modify)
    coltype = columnDataType(in_col)
    select case(coltype)
    case (Real64)
       dbledata => real64Data(in_col)
       buffer = dbledata
    case (Real32)
       sngldata => real32Data(in_col)
       buffer = sngldata
    case (Integer32)
       longdata => int32Data(in_col)
       buffer = longdata
    case (Integer16)
       intgdata => int16Data(in_col)
       buffer = intgdata
    case (Integer8)
       bytedata => int8Data(in_col)
       buffer = bytedata
    case default
       write(errstr,*) "input column ",qualifiedName(in_col),  &
                       " has an unknown type ", coltype
       call error("copy_data 01")
    end select
    call release(in_col)

  end subroutine copy_block
  !---------------------------------------------------------------------
  subroutine buildmosmap(mosevt, ev_map, projenergy, fromodf, nx, ny, x0, y0)	!Jean

! mosevt    : Array of event structure
! ev_map : Handle to the output array
! projenergy : Project the energy value (if no, project the counts) ?
! fromodf    : Is this an events file straight from the ODF ?
                                   
    type(sas_evt), dimension(:),intent(in) :: mosevt
    type(ArrayT), intent(in)               :: ev_map
    logical, intent(in)                    :: projenergy, fromodf
    
! Interface with the DAL/CAL
    integer(kind=int32), dimension(:,:), pointer   :: map
    integer(kind=int8),  dimension(:,:,:), pointer :: patterns
    integer(kind=int16)                            :: eduThreshold
! Local variables
    integer,parameter :: dx1=5, dx2=5, dy1=0, dy2=2

!    integer,parameter :: x_size_window=EMOS_MAX_x+dx1+dx2
!    integer,parameter :: y_size_window=EMOS_MAX_Y+dy1+dy2

!    integer(kind=int32), dimension(-2:x_size_window,-2:y_size_window) :: image
    integer(kind=int16), dimension(-1:1,-1:1,0:edu_npat-1) :: patabove
    integer(kind=int32), dimension(:,:), pointer :: image
    integer :: npattern, jr, nx, ny, x_size_window, y_size_window, x0, y0


    x_size_window=600+dx1+dx2
    y_size_window=600+dx1+dx2
!    x_size_window=nx+dx1+dx2
!    y_size_window=ny+dx1+dx2
!    allocate(image(-2:x_size_window,-2:y_size_window))    
!    allocate(image(-2-x0+1:x_size_window-x0+1,-2-y0+1:y_size_window-y0+1))    !old 26/10/00
!    allocate(image(-3+x0:x_size_window-1+x0,-3+y0:y_size_window-1+y0))    
    allocate(image(-3+1:x_size_window-1+1,-3+1:y_size_window-1+1))    

! Read the pattern library
    call CAL_getEventPatterns(patterns, eduThreshold)

! Transpose the pattern library
! Set the 2s and the central 1 to 0
    do npattern = 0,edu_npat-1
       do jr = -1,1
          patabove(:,jr,npattern) = patterns(npattern,jr+2,1:3)
       enddo
    enddo
    where (patabove > 1)
       patabove = 0
    endwhere
    patabove(0,0,:) = 0

! Initialise the image to 0
    image = 0

! Project the events on a larger image to avoid unpleasant surprises
    if (projenergy) then
       call projectEventsEnergy(mosevt, patabove, image)
    else
       call projectEventsCounts(mosevt, patabove, image)
    endif
    write(errstr,*) "Total signal projected to MOS map: ", sum(image)
    call message(AppMsg,Noisy)

! Write the relevant part of the image to the output file
! This is offset because of (-2,-2) in projectEvents
    map => int32Array2Data(ev_map)
    if (fromodf) then
    !   map = image(dx1:nx+dx1-1,dy1:ny+dy1-1)
    else
       map = image(x0-1-1:x0-1+nx-2,y0-1-1:y0-1+ny-2)
    endif
    write(errstr,*) "Total signal within MOS CCD area : ", sum(map)
    call message(AppMsg,Noisy)



  end subroutine buildmosmap
  !---------------------------------------------------------------------
  subroutine flicker(nx, ny, start, rxcol, rycol, timecol, instrument, &
                     x0, y0, Nbpix, a_rawX, a_rawY, a_badPixType, a_yextent, &
                     nblocks, timestep, valueFmos, phacol, en_lo, en_hi, good)

    type(ColumnT) :: rxcol, rycol, timecol, phacol

    integer(int16), dimension(:) :: a_rawX, a_rawY, a_badPixType, &
                                    a_yextent

    integer(int16), dimension(:), pointer   :: f_rx, f_ry, f_pha
    integer(kind=int32), pointer            :: evxy(:,:), maxevxy(:,:)

    integer :: nx, ny, x0, y0, nblocks, x, y, n, blocknr, evtot, Nbpix, NbpixF, Ci, &
               Cnum, facCi, extent, Npnoutwin

    integer(Int8), dimension(0:nx-1,0:ny-1) :: good

    real(kind=Double), pointer :: valueF(:,:,:), valueFmos(:,:,:)
    real(kind=Double), dimension(:), pointer :: f_time, Cpois, Cdata

    real(kind=Double) :: start, timestep, blockmax, blockmin, chi2, mean, redchi2, &
                         chi2thresh, KSstat, KSthresh, KSmax, en_lo, en_hi

    character(len=5) :: instrument
    character(len=120) :: expression

    logical          :: isflicker, isbright, yextentfound

    real, parameter  :: e = 2.718281828E0

    !--------------------------------------------------------------------
    !ALLOCATE AND CLEAR MAIN ARRAY    
    !--------------------------------------------------------------------
    allocate(valueF(0:nx-1,0:ny-1,0:nblocks-1))
    do x = 0, nx-1
      do y = 0, ny-1
        do n = 0, nblocks-1
          valueF(x,y,n) = 0.0 
        enddo
      enddo
    enddo
    f_time => real64Data(timecol)
    f_rx => int16Data(rxcol)
    f_ry => int16Data(rycol)
    !--------------------------------------------------------------------
    ! IF PN, get valueF
    !--------------------------------------------------------------------
    if (instrument == "EPN") then
      f_pha => int16Data(phacol)	 ! see 5 lines above
      do blocknr = 1, nblocks
        blockmax = start + (blocknr * timestep)
        blockmin = blockmax - timestep
        Npnoutwin = 0 
        do n = 0, size(f_rx)-1
          if (f_pha(n) >= en_lo .and. f_pha(n) <= en_hi) then 	!within energy range
            if (f_rx(n) <= nx+x0-1 .and. f_rx(n) >= x0 .and. &
                f_ry(n) <= ny+y0-1 .and. f_ry(n) >= y0) then 
              if (f_time(n) >= blockmin .and. f_time(n) < blockmax) then 
                valueF(f_rx(n)-x0,f_ry(n)-y0,blocknr-1) = & 
                      valueF(f_rx(n)-x0,f_ry(n)-y0,blocknr-1) + 1
              endif
            else
              Npnoutwin = Npnoutwin + 1
            endif
          endif
        enddo
        if (Npnoutwin > 0) then 
          call warning("eventsOutOfWindow","Events out of X/Y range - ignored")
        endif 
      enddo
    endif

    !--------------------------------------------------------------------
    ! IF MOS, get valueF 
    !--------------------------------------------------------------------
    if (instrument == "EMOS1" .or. instrument == "EMOS2") then
      do n = 0, nblocks-1
        do x = 0, nx-1
          do y = 0, ny-1
            valueF(x,y,n) = valueFmos(x,y,n)
          enddo
        enddo
      enddo
    endif
    !--------------------------------------------------------------------
    ! Check array + calc counts/pix (mean then this/nblocks) + max counts/pix
    !--------------------------------------------------------------------
    evtot = 0
    allocate(evxy(0:nx-1,0:ny-1))
    allocate(maxevxy(0:nx-1,0:ny-1))
    do x = 0, nx-1
      do y = 0, ny-1
        evxy(x,y) = 0
        maxevxy(x,y) = 0
        do n = 0, nblocks-1
          evxy(x,y) = evxy(x,y) + valueF(x,y,n)
          evtot = evtot + valueF(x,y,n)
          if (maxevxy(x,y) < valueF(x,y,n)) then 
            maxevxy(x,y) = valueF(x,y,n)
          endif
        enddo
      enddo
    enddo
!if (evtot /= size(f_time)) then 
!write (*,*) "Check ",evtot,size(f_time)
!endif
    !--------------------------------------------------------------------
    ! GET FLICKER PARAMETERS
    !--------------------------------------------------------------------
    KSthresh = realParameter("flickerksthresh")  
    chi2thresh = realParameter("flickerchisqthresh")
    NbpixF = 0
    !--------------------------------------------------------------------
    !  MAIN LOOP THROUGH X/Y
    !--------------------------------------------------------------------
    yextentfound = .FALSE.
    extent = 0
    isbright = .FALSE.
    do x = 0, nx-1 
      do y = 0, ny-1
        isflicker = .FALSE.
        mean = real(real(evxy(x,y))/nblocks)
        !--------------------------------------------------------------------
        !  CHOOSE low/high count - here low to go in KS-Poiss test
        !--------------------------------------------------------------------
        if (maxevxy(x,y) < 13) then !dim enough avoids factorial probs
          Cnum = maxevxy(x,y)+1
          allocate(Cdata(0:Cnum))
          do Ci = 0, Cnum
            Cdata(Ci) = 0.0
          enddo        
          Cdata(0) = 0.0
          Cdata(Cnum) = real(nblocks)
          do Ci = 1, Cnum-1 
            do n = 0, nblocks-1
              if (nint(valueF(x,y,n)) < Ci) then   
                Cdata(Ci) = Cdata(Ci) + 1 
              endif
            enddo
          enddo   
          do Ci = 0, Cnum 
            Cdata(Ci) = Cdata(Ci)/nblocks
          enddo
          allocate(Cpois(0:Cnum))
          Cpois(0) = 0.0
          Cpois(Cnum) = 1.0
          do Ci = 1, Cnum-1
            facCi = 1
            if (Ci >= 3) then 
              do n = 3, Ci
                facCi = facCi * (n-1)
              enddo        
            endif
            Cpois(Ci) = Cpois(Ci-1) + ((mean**(Ci-1))*(e**(-1*mean))/(facCi))
          enddo
!do Ci = 0, Cnum
!write (*,*) "Cpois",Cpois(Ci)
!enddo
          KSmax = 0.0
          do Ci = 1, Cnum
            KSstat = abs(Cpois(Ci) - Cdata(Ci))
            if (KSstat > KSthresh) then
              isflicker = .TRUE.
              isbright = .FALSE.
            endif
            if (KSstat > KSmax) KSmax = KSstat
          enddo
          !--------------------------------------------------------------------
          !  ELSE bright - Chi2 test
          !--------------------------------------------------------------------
        else  !bright pixels - can do Chi2
          chi2 = 0.0
          mean = evxy(x,y)/nblocks
          do n = 0, nblocks-1
            chi2 = chi2 + (((valueF(x,y,n) - mean)**2)/mean)
          enddo
          redchi2 = chi2/(nblocks-1)
          if (redchi2 >= chi2thresh) then 
            isflicker = .TRUE.
            isbright = .TRUE.
          endif
        endif	!bright/dim
        !--------------------------------------------------------------------
        !  if FLICKER, fill array, check extent
        !--------------------------------------------------------------------
 120            format(" Flickering pixel (redChi2=",F7.3,") found at ",I3,",",I3," ") 
 121            format(" Flickering pixel (KS-stat=",F7.3,") found at ",I3,",",I3," ") 
        if (isflicker) then     
          NbpixF = NbpixF + 1
          Nbpix = Nbpix + 1
          a_rawX(Nbpix) = x+x0
          a_rawY(Nbpix) = y+y0
          a_badPixType(Nbpix) = 2
            ! check for extent
          if (Nbpix == 1) then 
            if (isbright) then 
              write(expression,120) redchi2,x+x0,y+y0
            else
              write(expression,121) KSmax,x+x0,y+y0
            endif
            good(x,y) = 0
            write(errstr,*) trim(expression)
            call message(AppMsg,Verbose)
            a_yextent(Nbpix) = 1
          endif
          if (Nbpix >= 2) then
            if (a_rawX(Nbpix) == a_rawX(Nbpix-1) .and. &
                a_rawY(Nbpix) == a_rawY(Nbpix-1)+1+extent .and. &
                a_badPixType(Nbpix) == a_badPixType(Nbpix-1)) then            !extent
              yextentfound = .TRUE.
              good(x,y) = 0
              extent = extent + 1
              Nbpix = Nbpix - 1
              NbpixF = NbpixF - 1
            else if (a_rawX(Nbpix) /= a_rawX(Nbpix-1) .or. &
                     a_rawY(Nbpix) /= a_rawY(Nbpix-1)+1+extent .or. &
                     a_badPixType(Nbpix) /= a_badPixType(Nbpix-1)) then       !extent ended
              if (yextentfound) then
                a_yextent(Nbpix-1) = extent + 1
                write (errstr,*) "    starts column of extent ",extent + 1," pixels"
                call message(AppMsg,Verbose)
                yextentfound = .FALSE.
                extent = 0
              endif
              if (.not.yextentfound) then
                a_yextent(Nbpix) = 1
                if (isbright) then 
                  write(expression,120) redchi2,x+x0,y+y0
                else
                  write(expression,121) KSmax,x+x0,y+y0
                endif
                good(x,y) = 0
                write(errstr,*) trim(expression)
                call message(AppMsg,Verbose)
              endif
            endif
          endif
        endif   !is flicker?
      enddo	!X/Y LOOP
    enddo
    !-------------------------------------------------------------
    ! Close yextent waiting (if exists)
    !-------------------------------------------------------------
    if (yextentfound) then
      a_yextent(Nbpix) = extent + 1
      write (errstr,*) "    starts column of extent ",extent + 1," pixels"
      call message(AppMsg,Verbose)
      yextentfound = .FALSE.
      extent = 0
    endif

  end subroutine flicker
  !---------------------------------------------------------------------
  subroutine hotcheck(psfthresh, valueR, x, y, x0, y0, nx, ny, cellsize, ccdnode, bckgrnd, ishot, frac, good)

    type(PsfT)                                 :: psf
    type(PsfWindowT)                           :: window
!    type(PsfValidityRangesT)                   :: valRange
    type(PsfBinSizeT)                          :: binSize
    real(kind=Double), pointer                 :: valueR(:,:)
    real(kind=single), dimension(:,:), pointer :: PSFmap
    real(kind=double), dimension(:), pointer   :: xmm1, ymm1, zmm1, &
                                                  xmm2, ymm2, zmm2, & 
						  theta, phi

    real(kind=double)                          :: E, theta_in, phi_in, &
                                                  bckgrnd, sum, fracpix, fracPSF, frac, &
                                                  psfthresh, sum2

    integer(kind=int16), dimension(0:0)        :: rawX, rawY
    integer(kind=int16), dimension(:), pointer :: chipX, chipY
    integer(kind=int8), dimension(0:0)         :: nodes

    integer 	:: cellsize, x, y, Xoff, Yoff, ccdnode, x0, y0, nx, ny, edgecode, cx1, &
                   cx2, cy1, cy2, numsum1, numsum2

    integer(Int8), dimension(0:nx-1,0:ny-1) :: good

    logical     :: ishot, edgeprob, binSizeChangeable, wasgood
    !------------------------------------------------------------- 
    !  	first calculate if edgeproblem, If then calc c1, c1
    !-------------------------------------------------------------
    edgeprob=.FALSE.
    edgecode = 0
    if (x-cellsize < 0) then 
      edgeprob = .TRUE.
      cx1 = 0
      cx2 = cellsize      
      if (y-cellsize < 0) then 
        edgecode = 1
        cy1 = 0
        cy2 = cellsize
      elseif (y+cellsize > ny-1) then
        edgecode = 3
        cy1 = -cellsize
        cy2 = 0
      else
        edgecode = 2
        cy1 = -cellsize
        cy2 = cellsize
      endif
    endif
    if (x+cellsize > nx-1) then 
      cx1 = -cellsize
      cx2 = 0
      edgeprob = .TRUE.
      if (y-cellsize < 0) then 
        edgecode = 7
        cy1 = 0
        cy2 = cellsize
      elseif (y+cellsize > ny-1) then
        edgecode = 5
        cy1 = -cellsize
        cy2 = 0
      else
        edgecode = 6
        cy1 = -cellsize
        cy2 = cellsize
      endif
    endif
    if (y-cellsize < 0 .and. x-cellsize >= 0 .and. x+cellsize <= nx-1) then 
      edgeprob = .TRUE.
      edgecode = 8
      cx1 = -cellsize
      cx2 = cellsize
      cy1 = 0
      cy2 = cellsize
    endif
    if (y+cellsize > ny-1 .and. x-cellsize >= 0 .and. x+cellsize <= nx-1) then 
      edgeprob = .TRUE.
      edgecode = 4
      cx1 = -cellsize
      cx2 = cellsize
      cy1 = -cellsize
      cy2 = 0
    endif
    if (edgeprob) then 
      write(errstr,*) "Pixel ",x+x0,y+y0," close to edge - edgecode= ",edgecode
      call message(AppMsg,Noisy)
    else ! pixel free from edge effects
      cx1 = -cellsize
      cx2 = cellsize
      cy1 = -cellsize
      cy2 = cellsize
    endif
    !------------------------------------------------------------- 
    !  	Get PSF at x,y
    !-------------------------------------------------------------
    rawX(0) = x+x0
    rawY(0) = y+y0
    nodes(0) = ccdnode
    call CAL_pixcoord1ToChipCoord(rawX, rawY, chipX, chipY, nodes)
    call CAL_ChipCoordToCamcoord1(chipX, chipY, xmm1, ymm1, zmm1)
    call CAL_Camcoord1ToCamcoord2(xmm1, ymm1, zmm1, xmm2, ymm2, zmm2)
    call CAL_Camcoord2ToTelcoord(xmm2, ymm2, zmm2, theta, phi)
!write (*,*) "rawX, rawY, nodes, chipX, chipY, xmm1, ymm1, zmm1, xmm2, ymm2, zmm2, theta, phi"
!write (*,*) rawX(0),rawY(0),nodes(0),chipX(0),chipY(0),xmm1(0),ymm1(0),zmm1(0),xmm2(0),ymm2(0),zmm2(0),theta(0),phi(0)
    theta_in = theta(0)
    if (theta_in >= 900.0) theta_in = 900.0
    phi_in = phi(0)
    E = 1000.0 		! E dependance? 1keV default
!theta_in = 0.0
!phi_in = 0.0
!write (*,*) "theta_in, phi_in"
!write (*,*) theta_in,phi_in
    call CAL_setState(accuracyLevel=0)
    psf = CAL_getPSF(E, theta_in, phi_in)
!valRange = CAL_psfValidityRanges()
!write (*,*) 'validity ranges: '
!write (*,*) 'eMin         : ', valRange%eMin
!write (*,*) 'eMax         : ', valRange%eMax
!write (*,*) 'thetaMin     : ', valRange%thetaMin
!write (*,*) 'thetaMax     : ', valRange%thetaMax
!write (*,*) 'phiMin       : ', valRange%phiMin
!write (*,*) 'phiMax       : ', valRange%phiMax
    window%halfx = CAL_getMiscellaneousDataValue("MM_PER_PIXEL_X") * (cellsize +0.5)
    window%halfy = CAL_getMiscellaneousDataValue("MM_PER_PIXEL_Y") * (cellsize +0.5)
    binSize = CAL_psfBinSize(psf)
    binSizeChangeable = CAL_psfBinSizeChangeable(psf);
    binSize%binX = CAL_getMiscellaneousDataValue("MM_PER_PIXEL_X")
    binSize%binY = CAL_getMiscellaneousDataValue("MM_PER_PIXEL_Y")
!write (*,*) 'bin sizes X Y   : ', binSize%binX, binSize%binY, binSizeChangeable
    call CAL_psfSetBinSize(psf,binsize)
    binsize = CAL_psfBinSize(psf)
!write (*,*) "MM/PIX X Y",CAL_getMiscellaneousDataValue("MM_PER_PIXEL_X"),CAL_getMiscellaneousDataValue("MM_PER_PIXEL_Y"),cellsize
!write (*,*) "windowhalf X Y",window%halfx,window%halfy
    call CAL_psfImage(psf, window, PSFmap)

!!!!!!! !not needed useful to see - test 
!do Xoff = 0, 2*cellsize
!  do Yoff = 0, 2*cellsize
!    write (*,*) Xoff,Yoff,PSFmap(Xoff,Yoff)
!  enddo          
!enddo
    call CAL_setState(accuracyLevel=1)

    !------------------------------------------------------------- 
    !  Calculate pix/psf -- large HOT, 1 = PSF, >>1 source/extended
    !  also conservative, as using most compact psf possible (central) - OK? yes!
    !-------------------------------------------------------------
    !-------------------------------------------------------------
    ! CALC % hot in tot (pix-bgnd)/(totalcell-bgnd) for hotpix
    !-------------------------------------------------------------
    !Fracs calculated not including neigbouring same-X pixels (columns)
    !       nor previously found bad pixels/columns nor uplinked bad pixels
    !-------------------------------------------------------------
    sum = 0.0
    sum2 = 0.0
    numsum1=0
    do Xoff = cx1,cx2
      do Yoff = cy1,cy2
        if (Xoff /= 0) then 
          sum2 = sum2 + (good(x+Xoff,y+Yoff)*((valueR(x+Xoff,y+Yoff))))
          numsum1=numsum1+1
        endif
      enddo          
    enddo
!experiment
    numsum2=numsum1
    wasgood=.FALSE.
    do Xoff = cx1,cx2
      do Yoff = cy1,cy2
        if (valueR(x+Xoff,y+Yoff) > (0.4*sum2) .and. good(x+Xoff,y+Yoff) == 1) then !ignore really bad neigbours
          good(x+Xoff,y+Yoff) = 0 
          wasgood=.TRUE.
          numsum2=numsum2-1
        endif
        if (Xoff /= 0) sum = sum + (good(x+Xoff,y+Yoff)*((valueR(x+Xoff,y+Yoff) - bckgrnd)))

!if (x==60 .and. y==136) then 
!  write (*,*) "xoff,yoff,good(x+Xoff,y+Yoff),sum,valueR(x+Xoff,y+Yoff),bckgrnd"
!  write (*,*) xoff,yoff,good(x+Xoff,y+Yoff),sum,valueR(x+Xoff,y+Yoff),bckgrnd
!endif
          
        if (valueR(x+Xoff,y+Yoff) > (0.4*sum2) .and. wasgood) good(x+Xoff,y+Yoff) = 1 ! back to good (for now) 
      enddo          
    enddo

    fracpix = (valueR(x,y)-bckgrnd)/(((numsum1/numsum2)*sum)+(valueR(x,y)-bckgrnd))
!if (x==60 .and. y==136) then
!write (*,*) "valueR(x,y),bckgrnd,sum",valueR(x,y),bckgrnd,sum
!write (*,*) "numsum1,numsum2,fracpix",numsum1,numsum2,fracpix
!endif
    !-------------------------------------------------------------
    ! CALC % hot in tot (pix)/(totalcell) for PSF
    !-------------------------------------------------------------
    sum = 0.0
    do Xoff = cellsize+cx1, cellsize+cx2 
      do Yoff = cellsize+cy1, cellsize+cy2
        if (Xoff-cellsize /= 0) sum = sum + (good(x-cellsize+Xoff,y-cellsize+Yoff) * PSFmap(Xoff,Yoff))
      enddo          
    enddo
    if (sum == 0) then ! test pixel surrounded by bad pixels - can't do comparison
      write(errstr,*) " Note - Cell pixels around ",x+x0,",",y+y0," all bad - can't perfom PSF comparison - ignoring"
      call message(AppMsg,Noisy)
      frac = 0
    else  
      fracPSF = PSFmap(cellsize,cellsize)/(sum+PSFmap(cellsize,cellsize))
      frac = fracpix/fracPSF
    endif
!if (x==0 .and. y==0) then 
!write (*,*) "fracpix,fracpsf,frac",fracpix,fracpsf,frac
!endif
    !-------------------------------------------------------------
    ! Compare with PSF (narrowerthapsf) - output ishot
    !-------------------------------------------------------------
    !is it hot
    if (frac > psfthresh) then  ! hot, not source
      ishot = .TRUE. 
!write (*,*) "x,y,edgecode,cx1,cx2,cy1,cy2,sum,fracpix,fracPSF,frac"
!write (*,*) x,y,edgecode,cx1,cx2,cy1,cy2,sum,fracpix,fracPSF,frac
    else
      ishot = .FALSE.
      write(errstr,*) "Pixels around ",x+x0,y+y0," within narrowerthanPSF range - ignoring"
      call message(AppMsg,Noisy)
    endif

  end subroutine hotcheck
  !---------------------------------------------------------------------
  subroutine hotcolcheck(psfthresh, coltot, colmedian, x, y, x0, y0, nx, ny, cellsize, ccdnode, bckgrnd, ishot, columnsearchlabel)

    type(PsfT)                                 :: psf
    type(PsfWindowT)                           :: window
!    type(PsfValidityRangesT)                   :: valRange
    type(PsfBinSizeT)                          :: binSize
    real(kind=Double), pointer                 :: coltot(:)
    real(kind=Double), pointer                 :: colmedian(:)
    real(kind=single), dimension(:,:), pointer :: PSFmap
    real(kind=double), dimension(:), pointer   :: xmm1, ymm1, zmm1, &
                                                  xmm2, ymm2, zmm2, &
                                                  theta, phi

    real(kind=double)                          :: E, theta_in, phi_in, &
                                                  bckgrnd, sum, fracpix, fracPSF, frac, &
                                                  psfthresh, colbckgrnd

    integer(kind=int16), dimension(0:0)        :: rawX, rawY
    integer(kind=int16), dimension(:), pointer :: chipX, chipY
    integer(kind=int8), dimension(0:0)         :: nodes

    integer 	:: cellsize, x, y, Xoff, ccdnode, x0, y0, nx, ny, cx1, &
                   cx2
!    integer(Int8), dimension(0:nx-1,0:ny-1) :: good

    logical     :: ishot, edgeprob, binsizechangeable
    character(len=7)                          :: columnsearchlabel 
    !------------------------------------------------------------- 
    !  	first calculate if edgeproblem, If then calc c1, c1
    !-------------------------------------------------------------
    edgeprob=.FALSE.
    if (x-cellsize < 0) then 
      edgeprob = .TRUE.
      cx1 = 0
      cx2 = cellsize      
    endif
    if (x+cellsize > nx-1) then 
      cx1 = -cellsize
      cx2 = 0
      edgeprob = .TRUE.
    endif
    if (edgeprob) then 
      write(errstr,*) "Column ",x+x0," close to edge "
      call message(AppMsg,Noisy)
    else ! carry on at mo       
      cx1 = -cellsize
      cx2 = cellsize
    endif
    !------------------------------------------------------------- 
    !  	Get PSF at x,y
    !-------------------------------------------------------------
    rawX(0) = x
    rawY(0) = y
    nodes(0) = ccdnode
    call CAL_pixcoord1ToChipCoord(rawX, rawY, chipX, chipY, nodes)
    call CAL_ChipCoordToCamcoord1(chipX, chipY, xmm1, ymm1, zmm1)
    call CAL_Camcoord1ToCamcoord2(xmm1, ymm1, zmm1, xmm2, ymm2, zmm2)
    call CAL_Camcoord2ToTelcoord(xmm2, ymm2, zmm2, theta, phi)
!write (*,*) "rawX, rawY, nodes, chipX, chipY, xmm1, ymm1, zmm1, xmm2, ymm2, zmm2, theta, phi"
!write (*,*) rawX(0),rawY(0),nodes(0),chipX(0),chipY(0),xmm1(0),ymm1(0),zmm1(0),xmm2(0),ymm2(0),zmm2(0),theta(0),phi(0)
    theta_in = theta(0)
    if (theta_in >= 900.0) theta_in = 900.0
    phi_in = phi(0)
    E = 1000.0 		! E dependance? 1keV default
!theta_in = 0.0
!phi_in = 0.0
!write (*,*) "theta_in, phi_in"
!write (*,*) theta_in,phi_in
    call CAL_setState(accuracyLevel=0)
    psf = CAL_getPSF(E, theta_in, phi_in)
!valRange = CAL_psfValidityRanges()
!write (*,*) 'validity ranges: '
!write (*,*) 'eMin         : ', valRange%eMin
!write (*,*) 'eMax         : ', valRange%eMax
!write (*,*) 'thetaMin     : ', valRange%thetaMin
!write (*,*) 'thetaMax     : ', valRange%thetaMax
!write (*,*) 'phiMin       : ', valRange%phiMin
!write (*,*) 'phiMax       : ', valRange%phiMax
    window%halfx = CAL_getMiscellaneousDataValue("MM_PER_PIXEL_X") * (cellsize +0.5)
    window%halfy = CAL_getMiscellaneousDataValue("MM_PER_PIXEL_Y") * (cellsize +0.5)
    binSize = CAL_psfBinSize(psf)
    binSizeChangeable = CAL_psfBinSizeChangeable(psf);
    binSize%binX = CAL_getMiscellaneousDataValue("MM_PER_PIXEL_X")
    binSize%binY = CAL_getMiscellaneousDataValue("MM_PER_PIXEL_Y")
!write (*, *) 'bin sizes X Y   : ', binSize%binX, binSize%binY, binSizeChangeable
    call CAL_psfSetBinSize(psf,binsize)
    binsize = CAL_psfBinSize(psf)
!write (*,*) "MM/PIX X Y",CAL_getMiscellaneousDataValue("MM_PER_PIXEL_X"),CAL_getMiscellaneousDataValue("MM_PER_PIXEL_Y"),cellsize
!write (*,*) "windowhalf X Y",window%halfx,window%halfy
    call CAL_psfImage(psf, window, PSFmap)

!not needed useful to see - test 
!do Xoff = 0, 2*cellsize
!  do Yoff = 0, 2*cellsize
!    write (*,*) Xoff,Yoff,PSFmap(Xoff,Yoff)
!  enddo          
!enddo
    call CAL_setState(accuracyLevel=1)
    !------------------------------------------------------------- 
    !  Calculate pix/psf -- large HOT, 1 = PSF, >>1 source/extended
    !  also conservative, as using most compact psf possible (central) - OK? yes!
    !-------------------------------------------------------------
    !-------------------------------------------------------------
    ! CALC % hot in tot (pix-bgnd)/(totalcell-bgnd) for hotpix
    !-------------------------------------------------------------
    sum = 0.0
    colbckgrnd = bckgrnd*(ny-y0)
    do Xoff = cx1,cx2
      if (columnsearchlabel == "TOTAL") then 
        sum = sum + (coltot(x+Xoff) - colbckgrnd)
      else
        sum = sum + (colmedian(x+Xoff) - (colbckgrnd/(ny-y0)))
      endif
    enddo
    if (columnsearchlabel == "TOTAL") then 
      fracpix = (coltot(x)-colbckgrnd)/(sum)
    else
      fracpix = (colmedian(x)-(colbckgrnd/(ny-y0)))/(sum)
    endif
    !-------------------------------------------------------------
    ! CALC % hot in tot (pix)/(totalcell) for PSF
    !-------------------------------------------------------------
    sum = 0.0
    do Xoff = cellsize+cx1, cellsize+cx2 
        sum = sum + PSFmap(Xoff,cellsize)
    enddo
    fracPSF = PSFmap(cellsize,cellsize)/(sum)
    frac = fracpix/fracPSF
    !-------------------------------------------------------------
    ! Compare with PSF (narrowerthapsf) - output ishot
    !-------------------------------------------------------------
    !is it hot
    if (frac > psfthresh) then  ! hot, not source
      ishot = .TRUE. 
    else
      ishot = .FALSE.
      write(errstr,*) "Column ",x+x0," within narrowerthanPSF range (OutofTime column?) - ignoring"
      call message(AppMsg,Noisy)
    endif

!write (*,*) "psfthresh",psfthresh
!write (*,*) "cx1,cx2,sum,fracpix,fracPSF,frac"
!write (*,*) cx1,cx2,sum,fracpix,fracPSF,frac

  end subroutine hotcolcheck
  !---------------------------------------------------------------------
end module badpixfind_mod
